<script>

const textNode = v => !v.tag && !!v.text

function set(base,path,value) {
  var parts = path.split('.');
  var o = base;
  let key;

  var last = parts.pop();

  for(var i in parts) {
    key = parts[i];

    if(key in o) {
      o = o[key];
    } else {
      o = o[key] = {};
    }
  }

  if(typeof value == 'function') {
    o[last] = value(o[last]);
  } else {
    o[last] = value;
  }

  return base;
}

const get = (base,path) => path.split('.').reduce((a,b) => a && a[b],base);

export default {
  props: ['label','note','error', 'value', 'disabled'],
  data() {
    return {
      hasContent: false,
      hasFocus: false,
    };
  },
  methods: {
    change(event) {
      this.hasContent = event.target.value.length > 0;
    },
    focus(event) {
      this.hasFocus = true;
    },
    blur(event) {
      this.hasFocus = false;
    }
  },
  render(h) {
    var def = this.field;
    if(def.length != 1) {
      throw new Error("FormField must have one node as default slot");
    }

    let hasContent = this.hasContent;

    set(def[0].data,'ref','input');

    let value = this.getValue;

    if(typeof value == 'string' && value.length > 0) {
      hasContent = true;
    }
    if(typeof value == 'number') {
      hasContent = true;
    }

    if(!def[0].data.on) def[0].data.on = {};

    // add an input watcher if there isn't one:
    set(def[0].data,'on.input',(existing) => {
      if(existing == this.change) return existing;
      if(typeof existing == 'function') { return [existing,this.change]; }
      if(!existing) { return [this.change] }
      if(existing.length) { return [...existing,this.change] };
    });

    if(def[0].data.attrs && def[0].data.attrs.placeholder) {
      set(def[0].data,'on.focus',(existing) => {
        if(existing == this.focus) return existing;
        if(typeof existing == 'function') { return [existing,this.focus]; }
        if (!existing) { return [this.focus]; }
        if (existing.length) { return [...existing, this.focus]; }
      });

      set(def[0].data,'on.blur',(existing) => {
        if(existing == this.blur) return existing;
        if(typeof existing == 'function') { return [existing,this.blur]; }
        if (!existing) { return [this.blur]; }
        if (existing.length) { return [...existing, this.blur]; }
      });
    }

    var classes = ['form-field'];
    if(hasContent) classes.push('has-content');
    if(this.hasFocus) classes.push('has-focus');
    if(this.note) classes.push('has-note');
    if(this.errorMessage) classes.push('has-error');
    return (
        <div class={classes.join(' ')}>
          <span class="placeholder">{this.label}</span>
        {def}
        {this.errorMessage?(this.errorMessage):<span />}
        {this.note?(<span class="note">{this.note}</span>):<span />}
        </div>
    )
  },
  computed: {
    errorMessage() {
      return this.$slots.error || this.error && (<span class="error">{this.error}</span>);
    },
    field() {
      return this.$slots.default.filter(v => !textNode(v));
    },
    getValue() {
      return get(this.field[0].data,'attr.value')
          || (!this.field[0].elm && get(this.field[0].data,'domProps.value'))
          || get(this.field[0].data,'props.value')
          || get(this.field[0].data,'model.value');
    },
  },
  watch: {
    value(newVal, oldVal) {
      const def = this.field;
      if(def[0].elm && typeof newVal != "undefined") {
        def[0].elm.value = newVal;
      }
      this.hasContent = newVal && newVal.length;
    },
  },
}

</script>
